#ifndef CHANNEL_SETTING_H
#define CHANNEL_SETTING_H

#include <TQObject.h>
#include <TGNumberEntry.h>
#include <TGComboBox.h>
#include <TGLabel.h>
#include "ClassDigitizer.h"
#include "macro.h"

#define NUM_CHANNEL_SETTING 21

class TGWindow;
class TGMainFrame;

class ChannelSetting{
  private:
    TGMainFrame * fMain;
    
    TGNumberEntry * boardIDEntry, * chIDEntry;
    
    TGComboBox * cbOnOff;
    TGComboBox * cbPolarity;
    TGComboBox * cbTraceOnOff;
    
    TGNumberEntry * entry[NUM_CHANNEL_SETTING];
    
    Digitizer ** digi;
    int NChannel;
    
  public:
    ChannelSetting(const TGWindow *p, UInt_t w, UInt_t h, Digitizer ** digi, int nDigi);
    virtual ~ChannelSetting();
    void CloseWindow() { printf("close ChannelSetting window\n"); delete this; }
    void ChangeBoard();
    void ChangeCh();
    void ChangeOnOff();
    void ChangePolarity();
    void ChangeTraceOnOff();   
    void ChangeID(int id);
    bool isOpened;
  
};
#endif
